#include <stdio.h>
#include <math.h>
#include <time.h>
#include "cpuclock.h"

int main(void)
{
  CPU_clock_t c;
  CPU_clock_t c_begin,c_end;
  clock_t t,t_begin,t_end;
  long k;

  t_begin = clock();
  c_begin = CPU_clock();

#if 1
  printf("%16Ld\t%016Lx\t%Lu\n", (long long)0, (long long)c_begin, (unsigned long long)c_begin);
#else
  printf("%16ld\t%016lx\t%lu\n", (long)0, (long)c_begin, (unsigned long)c_begin);
#endif

  for (k = 1; k <= 10000000L; ++k)
  {
	(void)sin(3.12345);
	if ((k % 500000L) == 0)
	{
	    c = CPU_clock();
#if 1
	    printf("%16Ld\t%016Lx\t%Lu\n", (long long)k, (long long)c, (unsigned long long)c);
#else
	    printf("%16ld\t%016lx\t%lu\n", (long)k, (long)c, (unsigned long)c);
#endif
	    t_end = t = clock();
	    if ((t - t_begin) > 5 * CLOCKS_PER_SEC) /* bail out after 5 sec */
		break;
	}
  }

  c_end = CPU_clock();

  printf("Time for test:      %10.3f sec\n", 
	 ((double)(t_end - t_begin)/(double)CLOCKS_PER_SEC));
  
  printf("CPU cycle range:    %10lg -- %10lg: delta = %10lg\n", 
	 (double)c_begin, (double)c_end, (double)(c_end - c_begin));

  printf("clock range:        %10ld -- %10ld: delta = %10ld\n", 
	 (long)t_begin, (long)t_end, (long)(t_end - t_begin));

  printf("CLOCKS_PER_SEC:     %10ld\n", (long)CLOCKS_PER_SEC);

  printf("Apparent CPU speed: %10.3f MHz\n",
	 ((double)(c_end - c_begin)/((double)(t_end - t_begin)/(double)CLOCKS_PER_SEC))/1000000.0);

  printf("CPU_CLOCKS_PER_SEC: %10.3f\n", (double)CPU_CLOCKS_PER_SEC());

  printf("sizeof(CPU_clock_t):%10ld\n", (long)sizeof(CPU_clock_t));

  return (0);
}
